﻿using System;
using System.Collections.Generic;
using System.Text;

namespace XDesigner.ORM
{
    [AttributeUsage( AttributeTargets.Class | AttributeTargets.Property )]
    public class ORMCommandTextAttribute : Attribute 
    {
        public ORMCommandTextAttribute()
        {
        }

        public ORMCommandTextAttribute(string commandText)
        {
            _CommandText = commandText;
        }

        private string _CommandText = null;

        public string CommandText
        {
            get { return _CommandText; }
            set { _CommandText = value; }
        }
    }
}
