﻿using System;
using System.Text;

namespace XDesigner.ORM
{
    /// <summary>
    /// Attribute to define dictionary
    /// </summary>
    [AttributeUsage( AttributeTargets.Assembly , AllowMultiple=true )]
    public class ORMDictionaryDefineAttribute : Attribute
    {
        public ORMDictionaryDefineAttribute(string name, string commandText)
        {
            this._Name = name;
            this._CommandText = commandText;
        }

        private string _Name = null;

        public string Name
        {
            get { return _Name; }
            set { _Name = value; }
        }

        private string _CommandText = null;

        public string CommandText
        {
            get { return _CommandText; }
            set { _CommandText = value; }
        }

        private string _ValueFieldName = null;

        public string ValueFieldName
        {
            get { return _ValueFieldName; }
            set { _ValueFieldName = value; }
        }

        private string _TextFieldName = null;

        public string TextFieldName
        {
            get { return _TextFieldName; }
            set { _TextFieldName = value; }
        }
    }
}
