﻿using System;
using System.Collections.Generic;
using System.Text;

namespace XDesigner.ORM
{
    [AttributeUsage( AttributeTargets.Property , AllowMultiple=true )]
    public class ORMDictionaryItemAttribute : Attribute
    {
        public ORMDictionaryItemAttribute(string text, object Value)
        {
            this._Text = text;
            this._Value = Value;
        }

        private string _Text = null;

        public string Text
        {
            get { return _Text; }
            set { _Text = value; }
        }

        private object _Value = null;

        public object Value
        {
            get { return _Value; }
            set { _Value = value; }
        }
    }
}
