﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace XDesigner.ORM
{
    public class ORMPerformanceCounter
    {
        public const string Name_Instance = "Instance";
        public const string Name_ExecuteCommand = "ExecuteCommand";

        private static Dictionary<string, long> myCounter = new Dictionary<string, long>();

        public static long Increment( string name )
        {
            long v = 1;
            if (myCounter.ContainsKey(name))
            {
                v = myCounter[name];
                v++;
                myCounter[name] = v;
            }
            else
            {
                myCounter[name] = v;
            }
            return v;
        }

        public static long GetValue(string name)
        {
            if (myCounter.ContainsKey(name))
                return myCounter[name];
            else
                return 0;
        }
    }
}
