﻿using System;
using System.Collections.Generic;
using System.Text;

namespace XDesigner.ORM
{
    public enum ORMRelationStyle
    {
        /// <summary>
        /// No relation
        /// </summary>
        None,
        /// <summary>
        /// Auto detect
        /// </summary>
        Auto,
        /// <summary>
        /// One to one relation
        /// </summary>
        OneToOne,
        /// <summary>
        /// One to many relation
        /// </summary>
        OneToMany,
        /// <summary>
        /// One to many relation, field sort child record key list.
        /// </summary>
        OneToManyWithKeyList
    }

}
