using System;

namespace XDesigner.Common
{
	/// <summary>
	/// ַṩ߽ӿ
	/// </summary>
	public interface IVariableProvider
	{
		/// <summary>
		/// жǷָƵı
		/// </summary>
		/// <param name="Name"></param>
		/// <returns>ǷָƵı</returns>
		bool Exists( string Name );
		/// <summary>
		/// ָƵıֵ
		/// </summary>
		/// <param name="Name"></param>
		/// <returns>ֵ</returns>
		string Get( string Name );
		/// <summary>
		/// ָƵıֵ
		/// </summary>
		/// <param name="Name"></param>
		/// <param name="Value">ֵ</param>
		void Set( string Name , string Value );
		/// <summary>
		/// б
		/// </summary>
		string[] AllNames
		{
			get;
		}
	}//public interface IVariableProvider

	
	
    ///// <summary>
    ///// ʹһֵʵֵַṩ߶
    ///// </summary>
    //public class DictionaryVariableProvider : IVariableProvider
    //{
    //    /// <summary>
    //    /// ʼ
    //    /// </summary>
    //    public DictionaryVariableProvider()
    //    {
    //        myValues = new XDictionary();
    //    }

    //    /// <summary>
    //    /// ʼ
    //    /// </summary>
    //    /// <param name="vars">ֵ</param>
    //    public DictionaryVariableProvider( XDictionary vars )
    //    {
    //        myValues = vars ;
    //    }
    //    private XDictionary myValues = null;
    //    /// <summary>
    //    /// ݵֵ
    //    /// </summary>
    //    public XDictionary Values
    //    {
    //        get{ return myValues ;}
    //    }
    //    /// <summary>
    //    /// ñֵ
    //    /// </summary>
    //    /// <param name="Name"></param>
    //    /// <param name="Value">ֵ</param>
    //    public void Set( string Name , string Value )
    //    {
    //        myValues[ Name ] = Value ;
    //    }
    //    /// <summary>
    //    /// жǷָƵı
    //    /// </summary>
    //    /// <param name="Name"></param>
    //    /// <returns>ǷָƵı</returns>
    //    public bool Exists(string Name)
    //    {
    //        return myValues.ContainsKey( Name );
    //    }

    //    /// <summary>
    //    /// ָƵıֵ
    //    /// </summary>
    //    /// <param name="Name"></param>
    //    /// <returns>ֵ</returns>
    //    public string Get(string Name)
    //    {
    //        foreach( object key in myValues.Keys )
    //        {
    //            if( Convert.ToString( key ) == Name )
    //            {
    //                return Convert.ToString( myValues[ key ]) ;
    //            }
    //        }
    //        return null;
    //    }
		
    //    /// <summary>
    //    /// б
    //    /// </summary>
    //    public string[] AllNames
    //    {
    //        get
    //        {
    //            System.Collections.ArrayList list = new System.Collections.ArrayList();
    //            foreach( object k in myValues.Keys )
    //            {
    //                list.Add( Convert.ToString( k ));
    //            }
    //            return ( string[] ) list.ToArray( typeof( string ));
    //        }
    //    }
    //}//public class HashTableVariableProvider : IVariableProvider

	
	/// <summary>
	/// ʹһϣбʵֵַṩ߶
	/// </summary>
	public class HashTableVariableProvider : IVariableProvider
	{
		/// <summary>
		/// ʼ
		/// </summary>
		public HashTableVariableProvider()
		{
			myValues = new System.Collections.Hashtable();
		}

		/// <summary>
		/// ʼ
		/// </summary>
		/// <param name="vars">ϣб</param>
		public HashTableVariableProvider( System.Collections.Hashtable vars )
		{
			myValues = vars ;
		}
		private System.Collections.Hashtable myValues = null;
		/// <summary>
		/// ݵĹϣб
		/// </summary>
		public System.Collections.Hashtable Values
		{
			get{ return myValues ;}
		}
		/// <summary>
		/// ñֵ
		/// </summary>
		/// <param name="Name"></param>
		/// <param name="Value">ֵ</param>
		public void Set( string Name , string Value )
		{
			myValues[ Name ] = Value ;
		}
		/// <summary>
		/// жǷָƵı
		/// </summary>
		/// <param name="Name"></param>
		/// <returns>ǷָƵı</returns>
		public bool Exists(string Name)
		{
			foreach( object key in myValues.Keys )
			{
				if( Convert.ToString( key ) == Name )
					return true;
			}
			return false;
		}

		/// <summary>
		/// ָƵıֵ
		/// </summary>
		/// <param name="Name"></param>
		/// <returns>ֵ</returns>
		public string Get(string Name)
		{
			foreach( object key in myValues.Keys )
			{
				if( Convert.ToString( key ) == Name )
					return Convert.ToString( myValues[ key ]) ;
			}
			return null;
		}
		
		/// <summary>
		/// б
		/// </summary>
		public string[] AllNames
		{
			get
			{
				System.Collections.ArrayList list = new System.Collections.ArrayList();
				foreach( object k in myValues.Keys )
				{
					list.Add( Convert.ToString( k ));
				}
				return ( string[] ) list.ToArray( typeof( string ));
			}
		}
	}//public class HashTableVariableProvider : IVariableProvider
//
//	/// <summary>
//	/// ʹһֵַʵֵַṩ߶
//	/// </summary>
//	public class StringDictionaryVariableProvider : IVariableProvider
//	{
//		/// <summary>
//		/// ʼ
//		/// </summary>
//		public StringDictionaryVariableProvider()
//		{
//			this.myDictionary = new System.Collections.Specialized.StringDictionary();
//		}
//
//		/// <summary>
//		/// ʼ
//		/// </summary>
//		/// <param name="dir">ֵַ</param>
//		public StringDictionaryVariableProvider( System.Collections.Specialized.StringDictionary dir )
//		{
//			this.myDictionary = dir ;
//		}
//		private System.Collections.Specialized.StringDictionary myDictionary = null;
//		/// <summary>
//		/// ֵַ
//		/// </summary>
//		public System.Collections.Specialized.StringDictionary Dictionary
//		{
//			get{ return myDictionary ;}
//			set{ myDictionary = value;}
//		}
//		/// <summary>
//		/// ñֵ
//		/// </summary>
//		/// <param name="Name"></param>
//		/// <param name="Value">ֵ</param>
//		public void Set( string Name , string Value )
//		{
//			myDictionary[ Name ] = Value ;
//		}
//		/// <summary>
//		/// жǷָƵı
//		/// </summary>
//		/// <param name="Name"></param>
//		/// <returns>ǷָƵı</returns>
//		public bool Exists(string Name)
//		{
//			return myDictionary.ContainsKey( Name );
//		}
//
//		/// <summary>
//		/// ָƵıֵ
//		/// </summary>
//		/// <param name="Name"></param>
//		/// <returns>ֵ</returns>
//		public string Get(string Name)
//		{
//			return myDictionary[ Name ] ;
//		}
//		
//		/// <summary>
//		/// б
//		/// </summary>
//		public string[] AllNames
//		{
//			get
//			{
//				return null;
//			}
//		}
//	}//public class StringDictionaryVariableProvider : IVariableProvider

	/// <summary>
	/// ڲǶַ
	/// </summary>
	public class VariableString
	{
		/// <summary>
		/// ʼ
		/// </summary>
		public VariableString()
		{
		}
		/// <summary>
		/// ʼ
		/// </summary>
		/// <param name="txt">ַ</param>
		public VariableString( string txt )
		{
			strText = txt ;
		}
		/// <summary>
		/// ʼ
		/// </summary>
		/// <param name="txt">ַ</param>
		/// <param name="PreFix">ַǰ׺</param>
		/// <param name="EndFix">ַ׺</param>
		public VariableString( string txt , string Prefix , string EndFix )
		{
			strText = txt ;
			this.strVariablePrefix = Prefix ;
			this.strVariableEndfix = EndFix ;
		}
        private bool bolNamedParameter = false;
        /// <summary>
        /// ʽʹò
        /// </summary>
        public bool NamedParameter
        {
            get { return bolNamedParameter; }
            set { bolNamedParameter = value; }
        }

        private string strParameterNamePrefix = "@";
        /// <summary>
        /// ǰ׺
        /// </summary>
        public string ParameterNamePrefix
        {
            get { return strParameterNamePrefix; }
            set { strParameterNamePrefix = value; }
        }
		private string strVariablePrefix = "[%" ;
		/// <summary>
		/// ǰ׺
		/// </summary>
		public string VariablePrefix
		{
			get{ return strVariablePrefix ;}
			set{ strVariablePrefix = value;}
		}
		private string strVariableEndfix = "%]";
		/// <summary>
		/// ׺
		/// </summary>
		public string VariableEndfix
		{
			get{ return strVariableEndfix ;}
			set{ strVariableEndfix = value;}
		}
		private IVariableProvider myVariables = new HashTableVariableProvider();
		/// <summary>
		/// ṩ,ĬΪһ HashTableVariableProvider ͵Ķ
		/// </summary>
		public IVariableProvider Variables
		{
			get{ return myVariables ;}
			set{ myVariables = value;}
		}
		/// <summary>
		/// ñ
		/// </summary>
		/// <param name="strName"></param>
		/// <param name="strValue">ֵ</param>
		public void SetVariable( string strName, string strValue )
		{
			if( myVariables != null )
				myVariables.Set( strName , strValue );
		}
		private string strText = null;
		/// <summary>
		/// ַ
		/// </summary>
		public string Text
		{
			get{ return strText ;}
			set{ strText = value;}
		}
		/// <summary>
		/// ַаı
		/// </summary>
		/// <returns>ɵַ</returns>
		public string[] GetVariableNames( )
		{
			string[] strItems = AnalyseVariableString( strText , strVariablePrefix , strVariableEndfix );
			if( strItems != null )
			{
				System.Collections.ArrayList list = new System.Collections.ArrayList();
				for( int iCount = 1 ; iCount < strItems.Length ; iCount += 2 )
				{
					list.Add( strItems[ iCount ] );
				}
				return ( string[] ) list.ToArray( typeof( string ));
			}
			return null;
		}

		/// <summary>
		/// ִб
		/// </summary>
		/// <returns>ַ</returns>
		public string Execute()
		{
			return Execute( this.strText , null );
		}
		public string Execute( System.Collections.ArrayList ParameterValues )
		{
			return Execute( this.strText , ParameterValues );
		}
		/// <summary>
		/// ִб
		/// </summary>
		/// <param name="txt">ԭʼַ</param>
		/// <param name="ParameterValues">б</param>
		/// <returns>ַ</returns>
		public string Execute( string txt , System.Collections.ArrayList ParameterValues )
		{
			if( this.myVariables == null )
				throw new System.InvalidOperationException("δ Variables ");

			if( txt == null || txt.Length == 0 )
				return txt ;

			string[] strItems = AnalyseVariableString( txt , strVariablePrefix , strVariableEndfix );
			if( strItems == null )
				return null;
			System.Text.StringBuilder myStr = new System.Text.StringBuilder();
            System.Collections.ArrayList names = new System.Collections.ArrayList();
			for( int iCount = 0 ; iCount < strItems.Length ; iCount ++ )
			{
                if ((iCount % 2) == 0)
                {
                    myStr.Append(strItems[iCount]);
                }
                else
                {
                    string strName = strItems[iCount];
                    bool bolParameter = strName.StartsWith("@");
                    if (bolParameter)
                    {
                        strName = strName.Substring(1);
                    }
                    string strValue = null;
                    if (myVariables.Exists(strName))
                    {
                        strValue = myVariables.Get(strName);
                    }
                    else
                    {
                        strValue = "";
                    }
                    if (ParameterValues != null && bolParameter)
                    {
                        if (bolNamedParameter)
                        {
                            string pname = strName.Trim();
                            if (ContainsString(names, pname))
                            {
                                for (int iCount2 = names.Count; iCount2 < 100; iCount2++)
                                {
                                    pname = "Parameter" + iCount2;
                                    if (ContainsString(names, pname) == false)
                                    {
                                        break;
                                    }
                                }
                            }
                            names.Add(pname);
                            ParameterValues.Add(pname);
                            ParameterValues.Add(strValue);
                            myStr.Append(" " + strParameterNamePrefix + pname + " ");
                        }
                        else
                        {
                            ParameterValues.Add(strValue);
                            myStr.Append(" ? ");
                        }
                    }
                    else
                    {
                        myStr.Append(strValue);
                    }
                }
			}
			return myStr.ToString();
		}

        private bool ContainsString(System.Collections.ArrayList list, string strValue)
        {
            strValue = strValue.Trim();
            for (int iCount = 0; iCount < list.Count; iCount++)
            {
                string v = (string)list[iCount];
                v = v.Trim();
                if (string.Compare(strValue, v, true) == 0)
                {
                    return true;
                }
            }
            return false;
        }
        /// <summary>
		/// һַ,ݿʼַͽַзָ,طָɵַ
		/// ЩַżԪΪʼַͽַĲ
		/// ַ"aaa[bbb]ccc"ַ"aaa","bbb","ccc"
		/// </summary>
		/// <param name="strText">ַ</param>
		/// <param name="strHead">ʼַ</param>
		/// <param name="strEnd">ַ</param>
		/// <returns>ɵַ</returns>
        public static string[] AnalyseVariableString(
            string strText,
            string strHead,
            string strEnd )
        {
            return AnalyseVariableString(strText, strHead, strEnd, false);
        }

		/// <summary>
		/// һַ,ݿʼַͽַзָ,طָɵַ
		/// ЩַżԪΪʼַͽַĲ
		/// ַ"aaa[bbb]ccc"ַ"aaa","bbb","ccc"
		/// </summary>
		/// <param name="strText">ַ</param>
		/// <param name="strHead">ʼַ</param>
		/// <param name="strEnd">ַ</param>
        /// <param name="EnableEmptyItem">ֿհĿ</param>
		/// <returns>ɵַ</returns>
		public static string[] AnalyseVariableString(
			string strText ,
			string strHead , 
			string strEnd ,
            bool EnableEmptyItem )
		{
			// ԭʼַЧûκοõĲ˳
			if(    strText 			== null 
				|| strHead			== null 
				|| strEnd 			== null 
				|| strHead.Length	== 0 
				|| strEnd.Length	== 0 
				|| strText.Length	== 0 )
				return new string[]{ strText };
			
			int 	index = strText.IndexOf( strHead );
			// ԭʼַûб˳
			if(index < 0 ) 
				return new string[]{ strText } ;
			
			System.Collections.ArrayList myList = new System.Collections.ArrayList();
			string 	strKey ;
			int 	index2 ;
			int 	LastIndex = 0 ;
			do
			{	
				//  "[]" ʽַ
				// ûҵ "["  "]"ַ˳ѭ
				index2 = strText.IndexOf( strEnd ,  index + 1  );
				if(index2 > index)
				{
                    //  ] ǰ [ 
					index = LastIndexOfRange(strText, strHead, LastIndex, index2);
                    if (index == -1)
                    {
                        break;
                    }
					 
					// ַԼŵַ,ַΪ
					// òЧֵ
					// 򲻽жĴ
					int len = index2 - index - strHead.Length ;
					if( len == 0 && EnableEmptyItem == false )
					{
						break;
					}

					strKey = strText.Substring(index + strHead.Length ,  len );
                    if (LastIndex < index)
                    {
                        string strItem = strText.Substring(LastIndex, index - LastIndex);
                        myList.Add( strItem );
                    }
                    else
                        myList.Add("");
					myList.Add( strKey );
					index = index2 +  strEnd.Length ;
					LastIndex = index ; 
				}
				else
				{
					break;
				}
			}while( index >=0 && index < strText.Length );
			// Ӵʣַ
			if(LastIndex < strText.Length   )
				myList.Add( strText.Substring(LastIndex));
			return (string[])myList.ToArray( typeof( string ));
		}//public static string[] AnalyseVariableString( string strText , string strHead , string strEnd )

        private static int LastIndexOfRange(
            string strText, 
            string strSearch,
            int StartIndex ,
            int EndIndex)
        {
            if (strText == null)
                throw new ArgumentNullException("strText");
            if (strSearch == null)
                throw new ArgumentNullException("strSearch");

            int LastIndex = strText.IndexOf(strSearch, StartIndex);
            if (LastIndex == -1)
                return -1;
            StartIndex += strSearch.Length;
            while (true)
            {
                int index = strText.IndexOf(strSearch, StartIndex);
                if (index == -1 || index >= EndIndex)
                {
                    return LastIndex;
                }
                LastIndex = index;
                StartIndex += strSearch.Length;
            }
            //return -1;
        }
	}//public class VariableString
}