﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XDesigner.ORM.Test
{
    public partial class frmGenerateHelperCode : Form
    {
        public frmGenerateHelperCode()
        {
            InitializeComponent();
        }

        private void frmGenerateHelperCode_Load(object sender, EventArgs e)
        {
            cboType.Items.Add(typeof(CustomerClass));
            cboType.Items.Add(typeof(EmployeeClass));
            cboType.Items.Add(typeof(OrderClass));
            cboType.Items.Add(typeof(OrderDetailClass));
            cboType.DisplayMember = "Name";
            cboType.SelectedIndex = 0;
        }

        private void btnGenerate_Click(object sender, EventArgs e)
        {
            Type t = cboType.SelectedItem as Type;
            txtSourceCode.Text = Program.ORM.GenerateHelperSourceCode(t);
        }
    }
}