﻿using System;
using System.Collections.Generic;
using System.Text;
using XDesigner.ORM;
using System.ComponentModel;

namespace XDesigner.ORM.DOM
{
    [Serializable()]
    public class ORMIDGenerateInfo : ICloneable
    {
        public ORMIDGenerateInfo()
        {
        }

        private ORMIDGenerateStyle _Style = ORMIDGenerateStyle.Increase;
        [DefaultValue( ORMIDGenerateStyle.Increase )]
        public ORMIDGenerateStyle Style
        {
            get { return _Style; }
            set { _Style = value; }
        }

        private string _Format = null;
        [DefaultValue(null)]
        public string Format
        {
            get { return _Format; }
            set { _Format = value; }
        }

        public ORMIDGenerateInfo Clone()
        {
            return (ORMIDGenerateInfo)((ICloneable)this).Clone();
        }

        object ICloneable.Clone()
        {
            ORMIDGenerateInfo info = new ORMIDGenerateInfo();
            info._Format = this._Format;
            info._Style = this._Style;
            return info;
        }

    }
}
