using System;
using System.Collections.Generic;
using System.Text;
using System.Data ;
using System.Collections;
using XDesigner.ORM;

namespace XDesigner.DataSourceDom
{
    /// <summary>
    /// Ϣ
    /// </summary>
    [Serializable()]
    public class UpdateValueInfo
    {
        /// <summary>
        /// ݸϢ
        /// </summary>
        /// <param name="bindFieldName">󶨵ֶ</param>
        /// <param name="keyFieldName">ؼֶ</param>
        /// <param name="keyValue">ؼֵֶ</param>
        /// <param name="Value">Ҫֵֶ</param>
        /// <returns>õĸϢ</returns>
        public static UpdateValueInfo Create(
            string bindFieldName,
            string keyFieldName, 
            string keyValue, 
            object Value)
        {
            // 
            if (bindFieldName == null || bindFieldName.Trim().Length == 0)
                return null;
            if (keyFieldName == null || keyFieldName.Trim().Length == 0)
                return null;
            bindFieldName = bindFieldName.Trim();
            keyFieldName = keyFieldName.Trim();

            int index = bindFieldName.IndexOf('.');
            if (index > 0)
            {
                // Ҫݱ
                string tableName = bindFieldName.Substring(0, index).Trim();
                bindFieldName = bindFieldName.Substring(index + 1).Trim();
                index = keyFieldName.IndexOf('.');
                if (index > 0)
                {
                    string tableName2 = keyFieldName.Substring(0, index).Trim();
                    keyFieldName = keyFieldName.Substring(index + 1).Trim();
                    if (string.Compare(tableName, tableName2, true) == 0)
                    {
                        UpdateValueInfo info = new UpdateValueInfo();
                        info.TableName = tableName;
                        info.FieldName = bindFieldName;
                        info.KeyFieldName = keyFieldName;
                        info.Value = Value;
                        info.KeyValue = keyValue;
                        return info;
                    }
                }
            }
            return null;
        }

        /// <summary>
        /// ʼ
        /// </summary>
        public UpdateValueInfo()
        {
        }

        private string strTableName = null;
        /// <summary>
        /// ݱ
        /// </summary>
        public string TableName
        {
            get
            {
                return strTableName;
            }
            set
            {
                strTableName = value;
            }
        }

        private string strKeyFieldName = null;
        /// <summary>
        /// ؼֶ
        /// </summary>
        public string KeyFieldName
        {
            get
            {
                return strKeyFieldName;
            }
            set
            {
                strKeyFieldName = value;
            }
        }

        private string strKeyValue = null;
        /// <summary>
        /// ؼֵֶ
        /// </summary>
        public string KeyValue
        {
            get
            {
                return strKeyValue;
            }
            set
            {
                strKeyValue = value;
            }
        }

        private string strFieldName = null;
        /// <summary>
        /// ֵֶ
        /// </summary>
        public string FieldName
        {
            get
            {
                return strFieldName;
            }
            set
            {
                strFieldName = value;
            }
        }

        //private object objOldValue = null;
        //[System.Xml.Serialization.XmlIgnore()]
        //[System.ComponentModel.Browsable( false )]
        //public object OldValue
        //{
        //    get
        //    {
        //        return objOldValue;
        //    }
        //    set
        //    {
        //        objOldValue = value;
        //    }
        //}


        //public string OldValueString
        //{
        //    get
        //    {
        //        return Convert.ToString(objOldValue);
        //    }
        //    set
        //    {
        //        objOldValue = value;
        //    }
        //}


        private object objValue = null;
        /// <summary>
        /// ֵֶ
        /// </summary>
        [System.Xml.Serialization.XmlIgnore()]
        [System.ComponentModel.Browsable(false)]
        public object Value
        {
            get
            {
                return objValue;
            }
            set
            {
                objValue = value;
            }
        }

        /// <summary>
        /// ֵֶַʽ
        /// </summary>
        public string ValueString
        {
            get
            {
                return Convert.ToString(objValue);
            }
            set
            {
                objValue = value;
            }
        }

        [NonSerialized()]
        private object objSource = null;
        /// <summary>
        /// Դ
        /// </summary>
        [System.ComponentModel.Browsable( false )]
        [System.Xml.Serialization.XmlIgnore()]
        public object Source
        {
            get
            {
                return objSource;
            }
            set
            {
                objSource = value;
            }
        }
    }

    /// <summary>
    /// ݿֶθϢб
    /// </summary>
    [Serializable()]
    public class UpdateValueInfoList : System.Collections.CollectionBase
    {
        /// <summary>
        /// ʼ
        /// </summary>
        public UpdateValueInfoList()
        {
        }

        /// <summary>
        /// ָŴĸϢ
        /// </summary>
        /// <param name="index"></param>
        /// <returns>Ϣ</returns>
        public UpdateValueInfo this[int index]
        {
            get
            {
                return (UpdateValueInfo)this.List[index];
            }
        }

        /// <summary>
        /// бϢ
        /// </summary>
        /// <param name="info">Ϣ</param>
        /// <returns>¶бе</returns>
        public int Add(UpdateValueInfo info)
        {
            return this.List.Add(info);
        }

        /// <summary>
        /// бɾָϢ
        /// </summary>
        /// <param name="info">ҪɾϢ</param>
        public void Remove(UpdateValueInfo info)
        {
            this.List.Remove(info);
        }
    }

    /// <summary>
    /// ݸִж
    /// </summary>
    public class UpdateValueExecuter
    {
        /// <summary>
        /// ʼ
        /// </summary>
        public UpdateValueExecuter()
        {
        }

        private UpdateValueInfoList myValues = new UpdateValueInfoList();
        /// <summary>
        /// Ϣб
        /// </summary>
        public UpdateValueInfoList Values
        {
            get
            {
                return myValues;
            }
            set
            {
                myValues = value;
            }
        }


        private ParameterStyle intParameterStyle = ParameterStyle.SQLServerStyle;
        /// <summary>
        /// 滻ʽ
        /// </summary>
        [System.ComponentModel.DefaultValue(ParameterStyle.SQLServerStyle)]
        [System.ComponentModel.Category("Data")]
        public ParameterStyle ParameterStyle
        {
            get
            {
                return intParameterStyle;
            }
            set
            {
                intParameterStyle = value;
            }
        }

        private bool bolDebugMode = false;
        /// <summary>
        /// Ƿڵģʽ
        /// </summary>
        public bool DebugMode
        {
            get
            {
                return bolDebugMode;
            }
            set
            {
                bolDebugMode = value;
            }
        }

        /// <summary>
        /// һ
        /// </summary>
        /// <param name="command"></param>
        /// <param name="fields"></param>
        /// <returns></returns>
        protected virtual int Update(IDbCommand command, ArrayList fields)
        { 
            // SQL
            StringBuilder mySQL = new StringBuilder();
            foreach (UpdateValueInfo info in fields)
            {
                if (mySQL.Length > 0)
                {
                    mySQL.Append(" , \r\n");
                }
                mySQL.Append(info.FieldName + " = ");
                DataSourceUtil.AppendParameterSQL(
                    mySQL , 
                    info.FieldName , 
                    info.Value , 
                    this.ParameterStyle );
            }//foreach
            UpdateValueInfo keyInfo = (UpdateValueInfo)fields[0];
            mySQL.Insert(0 , "Update " + keyInfo.TableName + " Set ");
            mySQL.Append(" Where " + keyInfo.KeyFieldName + " = " );
            DataSourceUtil.AppendParameterSQL(
                mySQL ,
                keyInfo.KeyFieldName ,
                keyInfo.KeyValue ,
                this.ParameterStyle );
            // SQL
            command.CommandText = mySQL.ToString();
            // 
            command.Parameters.Clear();
            if( intParameterStyle == ParameterStyle.Anonymous 
                || intParameterStyle == ParameterStyle.Default 
                || intParameterStyle == ParameterStyle.OracleStyle 
                || intParameterStyle == ParameterStyle.SQLServerStyle )
            {
                foreach( UpdateValueInfo info in fields )
                {
                    IDataParameter p = command.CreateParameter();
                    if( intParameterStyle == ParameterStyle.OracleStyle 
                        || intParameterStyle == ParameterStyle.SQLServerStyle
                        || intParameterStyle == ParameterStyle.Default )
                    {
                        p.ParameterName = info.FieldName ;
                    }
                    p.Value = info.Value ;
                    command.Parameters.Add( p );
                }
                IDataParameter p2 = command.CreateParameter();
                if (intParameterStyle == ParameterStyle.OracleStyle
                    || intParameterStyle == ParameterStyle.SQLServerStyle
                    || intParameterStyle == ParameterStyle.Default)
                {
                    p2.ParameterName = keyInfo.KeyFieldName;
                }
                p2.Value = keyInfo.KeyValue;
                command.Parameters.Add(p2);
            }
            // ִSQL
            if (this.DebugMode)
            {
                DataSourceUtil.DebugPrintCommandInfo("Data updater", command);
            }
            int result = command.ExecuteNonQuery();
            return result ;
        }
         

        /// <summary>
        /// 
        /// </summary>
        /// <param name="connection">ʹõݿӶ</param>
        /// <returns>Ӱļ¼</returns>
        public int Update(IDbCommand cmd)
        {
            // ֵֶз
            Hashtable records = new Hashtable();
            ArrayList infos = new ArrayList(this.Values);
            while (infos.Count > 0)
            {
                records[infos[0]] = new ArrayList();
                bool find = false;
                foreach (UpdateValueInfo keyInfo in records.Keys)
                {
                    for (int iCount = infos.Count - 1; iCount >= 0; iCount--)
                    {
                        UpdateValueInfo info = (UpdateValueInfo)infos[iCount];
                        if (string.Compare(keyInfo.KeyFieldName, info.KeyFieldName, true) == 0
                            && string.Compare(keyInfo.TableName, info.TableName, true) == 0
                            && string.Compare(keyInfo.KeyValue, info.KeyValue, true) == 0)
                        {
                            ArrayList list = (ArrayList)records[keyInfo];
                            list.Add(info);
                            infos.Remove(info);
                        }
                    }
                }
            }
            // 
            int result = 0;
            foreach (UpdateValueInfo keyInfo in records.Keys)
            {
                ArrayList fields = (ArrayList)records[keyInfo];
                result += Update(cmd, fields);
            }
            return result;
        }
    }//public class UpdateValueExecuter
}
